package io.accumulatenetwork.sdk.generated.apiv2;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("DataEntryQuery")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class DataEntryQuery implements Marshallable {
	private Url url;
	private byte[] entryHash;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public DataEntryQuery url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public DataEntryQuery url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getEntryHash() {
	    return entryHash;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setEntryHash(final byte[] value) {
	    this.entryHash = value;
	}

	public DataEntryQuery entryHash(final byte[] value) {
	    setEntryHash(value);
	    return this;
	}
	public DataEntryQuery entryHash(final String value) {
		try {
			setEntryHash(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.url == null)) {
            marshaller.writeUrl(1, this.url);
        }
        if (!(this.entryHash == null || this.entryHash.length == 0)) {
            marshaller.writeHash(2, this.entryHash);
        }
        return marshaller.array();
    }
}
